import{jsx as e,jsxs as i}from"react/jsx-runtime";import{useRef as a,useState as t,useCallback as r,useEffect as o}from"react";import{useForm as n}from"react-hook-form";import{yupResolver as s}from"@hookform/resolvers/yup";import*as l from"yup";import{VStack as d,Box as c,Text as m,Input as g,FormControl as h,FormLabel as f,InputGroup as p,InputRightElement as v,FormHelperText as u,Flex as b,Icon as j,FormErrorMessage as w,HStack as y,Button as O,Image as x,Progress as z,ButtonGroup as S}from"@chakra-ui/react";import{RiCheckLine as k,RiCheckboxCircleFill as D,RiErrorWarningFill as U}from"react-icons/ri";import{useWallet as C}from"@solana/wallet-adapter-react";import{randomizeFileName as I,uploadFiles as T}from"@strata-foundation/chat";import{useErrorHandler as q}from"@strata-foundation/react";import{useChatSdk as W}from"../../contexts/chatSdk.js";import{useChatStorageAccountKey as F}from"../../hooks/useChatStorageAccountKey.js";import{useLoadDelegate as E}from"../../hooks/useLoadDelegate.js";import{useWalletFromChatIdentifier as L}from"../../hooks/useWalletFromChatIdentifier.js";import{FormControlWithError as N}from"../form/FormControlWithError.js";import{STRATA_KEY as A}from"../../constants/globals.js";const B=l.object({name:l.string().required().max(28),identifier:l.string().required().max(28).matches(/^[a-zA-Z0-9\_]+$/g,"must be alphanumeric and not have any spaces"),image:l.mixed(),imageUrl:l.string()}).required(),K=({state:l,setState:K,onBack:_,onNext:R})=>{const{publicKey:V}=C(),{chatSdk:P}=W(),{handleErrors:Y}=q();F();const Z=a(null),{imageUploaded:$}=l.wizardData,[G,H]=t(!1),[J,M]=t(),[Q,X]=t(null),{delegateWallet:ee,error:ie}=E();Y(ie);const{register:ae,handleSubmit:te,watch:re,formState:{errors:oe},setValue:ne,setError:se,clearErrors:le}=n({mode:"onChange",resolver:s(B),defaultValues:{...l.wizardData}}),{name:de,identifier:ce,image:me,imageUrl:ge}=re(),{publicKey:he}=C(),{wallet:fe}=L(ce),pe={bg:"gray.200",_dark:{bg:"gray.800"}},ve={color:"black",_dark:{color:"gray.400"}},ue=r(((e,i,a)=>{if(""===e)X(null),le("identifier");else if(e.length>=6){const e=i?.equals(a);!i||e?X(!0):(X(!1),se("identifier",{message:".chat domain is already taken!"}))}}),[]);o((()=>{ue(ce,fe,V)}),[ce,fe]);return o((()=>{(async()=>{if(me){const e=new FileReader;if(e.onload=e=>{M(e.target?.result||"")},e.readAsDataURL(me),!ge){H(!0),I(me);let e=!1;try{const i=await T(P.provider,[me],ee);i&&i.length>0&&(ne("imageUrl",i[0]),e=!0,K({...l,wizardData:{...l.wizardData,imageUploaded:!0}}))}catch(e){Y(e)}finally{H(!1),e||(ne("imageUrl",void 0),ne("image",void 0),M(void 0),se("image",{message:"Image failed to upload, please try again"}),Z.current&&(Z.current.value=""))}}}else M(void 0)})()}),[me]),e("form",Object.assign({onSubmit:te((e=>{!he?.equals(A)&&e.identifier.length<6&&!fe?.equals(V)?se("identifier",{message:"Domain must be at least 6 characters."}):(K({...l,wizardData:{...l.wizardData,...e,imageUploaded:!0}}),R())}))},{children:i(d,Object.assign({w:"full",alignItems:"start",gap:6,spacing:0},{children:[i(c,{children:[e(m,Object.assign({fontWeight:"bold",fontSize:"md"},{children:"Let's Start with the Basic info"}),void 0),e(m,Object.assign({fontSize:"xs",fontWeight:"normal"},{children:"What do you want your chat to be called?"}),void 0)]},void 0),e(N,Object.assign({id:"name",label:"Name",errors:oe,help:"The name that will apper in the sidebar."},{children:e(g,Object.assign({id:"name",variant:"filled"},pe,ae("name")),void 0)}),void 0),i(h,Object.assign({isInvalid:!!oe.identifier?.message},{children:[e(f,Object.assign({htmlFor:"identifier"},{children:".chat Domain"}),void 0),i(p,{children:[e(g,Object.assign({id:"identifier",variant:"filled"},pe,ae("identifier")),void 0),Q&&e(v,{children:e(k,{fontSize:"1.5rem"},void 0)},void 0)]},void 0),oe.identifier?.message?i(w,Object.assign({fontSize:"xs",textTransform:"capitalize"},{children:[e(j,{as:U,mr:1,fontSize:"1.3rem"},void 0),oe.identifier.message]}),void 0):e(u,Object.assign({fontSize:"xs"},ve,{alignItems:"center",justifyContent:"center"},{children:Q?i(b,Object.assign({alignItems:"center",color:"green.500"},{children:[e(j,{as:D,mr:1,fontSize:"1.3rem"},void 0),e(c,{children:".chat domain is available!"},void 0)]}),void 0):'The shortlink for the chat, i.e "solana" for solana.chat. You will receive an NFT representing ownership of the chat domain.'}),void 0)]}),void 0),i(h,Object.assign({isInvalid:!!oe.image?.message},{children:[e(f,{children:"Upload Picture"},void 0),i(y,Object.assign({w:"full",spacing:4},{children:[e(O,Object.assign({size:"sm",colorScheme:"primary",variant:"outline",onClick:()=>Z.current.click(),disabled:G},{children:"Choose Image"}),void 0),me&&i(y,Object.assign({spacing:2,align:"center"},{children:[e(x,{alt:me?.name,w:"32px",h:"32px",src:J},void 0),e(m,Object.assign({color:"gray.500"},{children:me?.name}),void 0),$&&e(j,{w:"22px",h:"22px",color:"green.400",as:D},void 0)]}),void 0)]}),void 0),e("input",{id:"image",type:"file",accept:".png,.jpg,.gif,.mp4,.svg",multiple:!1,onChange:e=>{const i=e.target.files[0];ne("image",i||null),le("image")},ref:Z,style:{display:"none"}},void 0),oe.image?.message?i(w,Object.assign({fontSize:"xs",textTransform:"capitalize"},{children:[e(j,{as:U,mr:2,fontSize:"1.3rem"},void 0),oe.image.message]}),void 0):e(u,Object.assign({fontSize:"xs"},ve,{children:"The image that will appear in the sidebar."}),void 0),G&&e(z,{size:"xs",isIndeterminate:!0,colorScheme:"orange",mt:2},void 0)]}),void 0),i(S,Object.assign({variant:"outline",colorScheme:"primary",w:"full"},{children:[e(O,Object.assign({w:"full",onClick:_},{children:"Back"}),void 0),e(O,Object.assign({w:"full",variant:"solid",type:"submit",disabled:!de||!Q||!ge&&!me||G||!$,isLoading:G,loadingText:"Uploading image"},{children:"Next"}),void 0)]}),void 0)]}),void 0)}),void 0)};export{K as BasicInfo};
//# sourceMappingURL=BasicInfo.js.map
